$INTERFACE UDGGA1                                             97/12/01
$REM LU
  $CON0='1.0$P-8'
  $CON1='1.0$P-2'
  $CON2='1.0$P-60'
  $CON3='2.0$P 0'
  $ICON1=0
  $ICON2=4
  $ICON3=32
  $ICON4=5
  $ICON5=8
  $DEFAULT=2
  $IF(DEC='E') $DEFAULT=1
  $HELP
    METHOD SELECTION:
      1 - SINGLE  DOG-LEG STRATEGY
      2 - DOUBLE  DOG-LEG STRATEGY
      3 - OPTIMUM DOG-LEG STRATEGY
  $CHECK(MOS,DEFAULT,'1\2\3',3)
  $HELP
    UPPER BOUND FOR STEPSIZE PARAMETER
  $CHECK(ALF2,'1.0$P 6',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$AF($NA)')
  $ADD(REAL,'\B1\B2\B3\D3\S1')
  $IF(MOS=3)
    $ADD(REAL,'\D1\D2\G1\G2\S2')
  $ENDIF
  $DEFETA2='ETA0*1.0$P-3'
  CALL UOD1D1
  IF (IDECA.LT.0) THEN
  $IF(JARA='D')
    $ADD(REAL,'\$AG($NF*$NA)')
    $N='N'
    $IF(DEC='A')
      $ADD(REAL,'\$XS($NF)\$AFO($NA)')
      $ADD(INTEGER,'\$IAG($NF)')
      $IF(JASA='C')
        $HELP
          STORING PERMUTATIONS IN THE QR DECOMPOSITION:
            1 - CHANGES OF MATRIX ROWS
            2 - TWO LEVEL INDICES
        $CHECK(MOS2,2,'1\2',3)
      $ELSE
        $MOS2=2
      $ENDIF
      $HELP
        TYPE OF QR DECOMPOSITION:
          1 - PARTIAL QR DECOMPOSITION
          2 - TOTAL QR DECOMPOSITION
      $CHECK(MOS3,1,'1\2',3)
      $HELP
        PIVOTING IN THE HOUSEHOLDER QR DECOMPOSITION:
          1 - BASIC PIVOTING
          2 - BASIC PIVOTING WITH INCREMENTAL RANK DETERMINATION
          3 - INCREMENTAL RANK-REVEALING PIVOTING
      $CHECK(MOS4,1,'1\2\3',3)
      $IF(MOS4>1) $DEFETA2='1.0D-14'
      $IF(MOS2=1)
        $ADD(REAL,'\$GS($NF)')
        $IDECA=4
        IDECA=4
      $ELSEIF(MOS3=2)
        $ADD(REAL,'\$GS($NF)')
        $IDECA=4
        IDECA=4
      $ELSE
        $GS=XS
        $IDECA=3
        IDECA=3
      $ENDIF
      INF=0
      ENDIF
      IF (IDECA.EQ.0) THEN
$REM      IF (LD.LE.ZERO) CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
      ELSE IF (IDECA.EQ.3) THEN
      ELSE IF (IDECA.EQ.4) THEN
    $ELSEIF(DEC='E')
      $ADD(INTEGER,'\$IAG($NF)')
      $HELP
        STORING PERMUTATIONS IN THE LU DECOMPOSITION:
          1 - CHANGES OF MATRIX ROWS
          2 - TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2',3)
      $IDECA=2
      IDECA=2
      INF=0
      ENDIF
      IF (IDECA.EQ.0) THEN
      ELSE IF (IDECA.EQ.2) THEN
    $ELSEIF(DEC='Q')
      $ADD(REAL,'\$AFO($NA)')
      $IF(JASA='C')
        $HELP
          REPRESENTATION OF RECTANGULAR MATRICES:
            1 - TWO DIMENSIONAL ARRAY
            2 - ONE DIMENSIONAL ARRAY
        $CHECK(MOS2,1,'1\2',3)
      $ELSE
        $MOS2=2
        $MOS3=2
      $ENDIF
      $IF(MOS2=1) $MOS3=1
      $HELP
        RECONSTRUCTION OF THE ORTHOGONAL MATRIX Q:
          1 - MATRIX Q IS NOT EXPLICITLY CONSTRUCTED
          2 - MATRIX Q IS EXPLICITLY CONSTRUCTED AND UPDATED
      $CHECK(MOS3,1,'1\2',3)
      $IF(MOS2=1)
        $POMD='E'
      $ELSE
        $ADD(REAL,'\$H($NF*($NF+1)/2)')
        $POMD='D'
      $ENDIF
      $IF(MOS3=1)
        $ADD(REAL,'\$H($NA*$NF)\$XS($NF)')
      $ELSE
        $ADD(REAL,'\$H($NF*($NF+1)/2)')
      $ENDIF
      $IDECA=1
      IDECA=1
      INF=0
      ENDIF
      IF (IDECA.EQ.0) THEN
      ELSE IF (IDECA.EQ.1) THEN
    $ENDIF
  $ELSEIF(JARA='S')
    $N='NF'
    $ADD(REAL,'\$AG($MA)\$AFO($NA)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
    $IF(DEC='A')
      $IF(NUMBER=1)
        $IW1='IW1'
        $IW2='IW2'
        $ADD(REAL,'\$AG($MMAX)')
        $ADD(INTEGER,'\$JAG($MMAX)\$IH($NF+1)\$IW1(11*($NF+1))&
        \$IW2(6*($NA+1))')
        $IDECA=7
        IDECA=0
        INF=0
        ENDIF
        IF (IDECA.EQ.0) THEN
$REM        IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
        ELSE IF (IDECA.EQ.7) THEN
      $ELSE
        $BG='BG'
        $ADD(REAL,'\$BG($MMAX)\$AFO($NA+$NF)\$AFD($NA+$NF)')
        $IDECA=8
        IDECA=0
        INF=0
        ENDIF
        IF (IDECA.EQ.0) THEN
$REM        IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
        ELSE IF (IDECA.EQ.8) THEN
      $ENDIF
    $ELSEIF(DEC='E')
      $BG='BG'
      $IBG='IBG'
      $JBG='JBG'
      $ADD(REAL,'\$BG($MMAX)\$XO(2*$NF)')
      $ADD(INTEGER,'\$IBG($MMAX+1)\$JB(15)\$IB(5)\$IAG($NA+1)&
      \$JAG($MA)\$JBG($MA)')
      $HELP
        PRELIMINARY PERMUTATION OF THE JACOBIAN MATRIX
          0 - NO PERMUTATION
          1 - PERMUTATION TO BLOCK TRIANGULAR FORM
      $CHECK(MOS1,0,'0\1',3)
      $HELP
        PREFERRENCE OF SYMMETRIC PIVOTS
          0 - SYMMETRIC PIVOTS ARE NOT PREFERRED
          1 - SYMMETRIC PIVOTS ARE PREFERRED
      $CHECK(MOS2,0,'0\1',3)
      $POM=2
      $IDECA=2
      IDECA=0
      ENDIF
      IF (NIT-LIT.LE.1) IDEC=0
      IF (IDECA.EQ.0) THEN
$REM      IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
      ELSE IF (IDECA.EQ.2) THEN
    $ENDIF
  $ENDIF
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECA'
  CALL UOERR1('UD$(JARA)G$(DEC)1',1)
  GO TO $30
  ENDIF
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFETA2,REAL,4)
  $IF(JARA='D')
    $IF(DEC='A')
      IF (LD.LE.0) THEN
      IF (IDECA.EQ.0) THEN
      CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
      ELSE
      CALL UXVCOP(NA,$AF,$AFO)
      $IF(MOS2=1)
        CALL UXECHB(NA,$N,$AG,$AFO,$XS,IER)
        CALL UXECRM(IER,NA,$AG,$AFO,-1)
        CALL UXECTM(NA,$N,$AG,$AFO,$GS,IER)
        CALL UXVSBP($N,$IAG,$AFO,$GN)
        CALL UXVCOP($N,$AFO,$GN)
      $ELSE
        CALL UXD$(JASA)HB($N,NA,$AG,$IAG,$AFO,$XS,INF)
        CALL UXD$(JASA)UM($N,NA,$AG,$IAG,$AFO,$GN,IER,1)
        $IF(MOS3=2)
          CALL UXD$(JASA)TB($N,NA,$AG,$IAG,$GN,$GS,IER)
        $ENDIF
      $ENDIF
      ENDIF
$REM      ELSE IF (IDECA.EQ.1) THEN
$REM      IF (IPOM1.EQ.1) THEN
$REM      CALL UXVCOP($N,$GN,$GO)
$REM      ELSE
$REM      CALL UXVCOP($N,$AF,$AFO)
$REM      $IF(MOS2=1)
$REM        CALL UXECTM(NA,$N,$AG,$AFO,$GO,$GS,INF)
$REM        CALL UXECHM(NA,$N,$AG,$GO,$XS,INF)
$REM      $ELSE
$REM        CALL UXD$(JASA)TM($N,NA,$AG,$IAG,$AFO,$GO,$GS,IER,MOS3)
$REM        CALL UXD$(JASA)HM($N,NA,$AG,$IAG,$GO,$XS,INF)
$REM      $ENDIF
$REM      ENDIF
      ENDIF
    $ELSEIF(DEC='E')
      IF (LD.LE.0) THEN
      IF (IDECA.EQ.0) THEN
      CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
      ELSE
      CALL UXVCOP($N,$AF,$GN)
      $JOB=1
      $IF(LAPACK='YES')
        $IF (JASA='R') $JOB=0
        CALL UXDGLM($N,$AG,$IAG,$GN,$JOB)
      $ELSEIF(MOS2=1)
        $IF (JASA='R') $JOB=0
        CALL UXEGGM($N,$N,$AG,$IAG,$GN,$JOB)
      $ELSE
        $IF (JASA='C') $JOB=0
        CALL UXDGGM($N,$AG,$IAG,$GN,$XO,$JOB)
      $ENDIF
      ENDIF
$REM      ELSE IF (IDECA.EQ.1) THEN
$REM      IF (IPOM1.EQ.1) THEN
$REM      CALL UXVCOP($N,$GN,$GO)
$REM      ELSE
$REM      CALL UXVCOP($N,$AF,$GO)
$REM      $JOB=1
$REM      $IF(LAPACK='YES')
$REM        $IF (JASA='R') $JOB=0
$REM        CALL UXDGLM($N,$AG,$IAG,$GO,$JOB)
$REM      $ELSEIF(MOS2=1)
$REM        $IF (JASA='R') $JOB=0
$REM        CALL UXEGGM($N,$N,$AG,$IAG,$GO,$JOB)
$REM      $ELSE
$REM        $IF (JASA='C') $JOB=0
$REM        CALL UXDGGM($N,$AG,$IAG,$GO,$XO,$JOB)
$REM      $ENDIF
$REM      ENDIF
      ENDIF
    $ELSEIF(DEC='Q')
      IF (LD.LE.0) THEN
      $IF(MOS3=1)
        IF (IDECA.EQ.1) THEN
        CALL UXVCOP(NA,$AF,$AFO)
        CALL UX$(POMD)CQB($N,NA,$AG,$AFO,$XS)
        CALL UXD$(JASB)MM($POMA,$H,$AFO,$GN)
        ELSE
        CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
        ENDIF
      $ELSE
        CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
      $ENDIF
      IF (IDECA.EQ.1) THEN
      CALL UXVCOP($N,$GN,$GO)
      $IF(MOS3=1)
        CALL UX$(POMD)CRM(N,NA,$AG,$GN,-1)
      $ELSE
        CALL UXDPRM($N,$H,$GN,-1)
      $ENDIF
      ENDIF
      ELSE IF (IDECA.EQ.1) THEN
      IF (IPOM1.EQ.1) THEN
      CALL UXVCOP($N,$GN,$GO)
      $IF(MOS3=1)
        CALL UX$(POMD)CRB(N,NA,$AG,$GO,1)
      $ELSE
        CALL UXDPRB($N,$H,$GO,1)
      $ENDIF
      ELSE
      $IF(MOS3=1)
        CALL UXVCOP(NA,$AF,$AFO)
        CALL UX$(POMD)CQB($N,NA,$AG,$AFO,$XS)
        CALL UXD$(JASB)MM($POMA,$H,$AFO,$GO)
      $ELSE
        CALL UXD$(JASB)MM($POMA,$AG,$AF,$GO)
      $ENDIF
      ENDIF
      ENDIF
    $ENDIF
  $ELSEIF(JARA='S')
    $IF(DEC='A')
      CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
    $ELSEIF(DEC='E')
      CALL UXSCMM($N,$N,MA,$AG,$IAG,$JAG,$AF,$GN)
    $ENDIF
  $ENDIF
  B2=UXVDOT($N,$GN,$GN)
  GNORM=SQRT(B2)
  IF (KD.LE.0) THEN
  IF (GNORM.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  GO TO $30
  ENDIF
  ENDIF
  INITD=MAX(ABS(INITD),1)
  IF (IDECA.EQ.0) THEN
  $IF(JARA='D')
    $IF(DEC='A')
      CALL UXD$(JASA)MM($POMA,$AG,$GN,$AFO)
      ELSE
      $IF(MOS2=1)
        CALL UXVCOP($N,$GN,$AFO)
        CALL UXVSFP($N,$IAG,$AFO,$SN)
        CALL UXECTM(NA,$N,$AG,$AFO,$GS,IER)
        CALL UXECRM(IER,NA,$AG,$AFO,1)
        CALL UXECHM(NA,$N,$AG,$AFO,$XS,IER)
      $ELSE
        CALL UXVCOP($N,$GN,$SN)
        $IF(MOS3=2)
          CALL UXD$(JASA)TM($N,NA,$AG,$IAG,$SN,$GS,IER)
        $ENDIF
        CALL UXD$(JASA)UM($N,NA,$AG,$IAG,$SN,$AFO,IER,0)
        CALL UXD$(JASA)HM($N,NA,$AG,$IAG,$AFO,$XS,INF)
      $ENDIF
      ENDIF
      B1=UXVDOT(NA,$AFO,$AFO)
    $ELSEIF(DEC='E')
      CALL UXD$(JASA)MM($POMA,$AG,$GN,$SN)
      ELSE
      CALL UXVCOP($N,$GN,$SN)
      $JOB=0
      $IF(LAPACK='YES')
        $IF (JASA='R') $JOB=1
        CALL UXDGLM($N,$AG,$IAG,$SN,$JOB)
      $ELSEIF(MOS2=1)
        $IF (JASA='R') $JOB=1
        CALL UXEGGM($N,$N,$AG,$IAG,$SN,$JOB)
      $ELSE
        $IF (JASA='C') $JOB=1
        CALL UXDGGM($N,$AG,$IAG,$SN,$XO,$JOB)
      $ENDIF
      ENDIF
      B1=UXVDOT($N,$SN,$SN)
    $ELSEIF(DEC='Q')
      CALL UXD$(JASA)MM($POMA,$AG,$GN,$AFO)
      B1=UXVDOT(NA,$AFO,$AFO)
      ELSE
      CALL UXVCOP($N,$GN,$SN)
      $IF(MOS3=1)
        CALL UX$(POMD)CRM(N,NA,$AG,$SN,1)
      $ELSE
        CALL UXDPRM($N,$H,$SN,1)
      $ENDIF
      B1=UXVDOT($N,$SN,$SN)
      ENDIF
    $ENDIF
  $ELSEIF(JARA='S')
    $IF(DEC='A')
      CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$GN,$AFO)
      B1=UXVDOT(NA,$AFO,$AFO)
      ELSE
      CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$GN,$AFO)
      B1=UXVDOT(NA,$AFO,$AFO)
      ENDIF
    $ELSEIF(DEC='E')
      CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$GN,$AFO)
      ELSE
      CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$GN,$AFO)
      ENDIF
      B1=UXVDOT(NA,$AFO,$AFO)
    $ENDIF
  $ENDIF
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  IF (B1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(B2/B1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  $IF(MOS=3)
    IF (IDECA.EQ.0) THEN
    $IF(JARA='D')
      $IF(DEC='A')
*
*     HOUSEHOLDER DECOMPOSITION
*
        S1=ETA2
        $IF(MOS2=1)
          S1=SQRT(S1)
          CALL UXECHF(NA,$N,$AG,$IAG,$XS,$GO,$SN,INF)
          CALL UXECHP(NA,$N,$AG,S1,$GO,$SN,INF,IER)
          CALL UXECTF(NA,$N,$AG,$GS,IER)
        $ELSE
          $IF(MOS4=3)
            CALL UXD$(JASA)HC($N,NA,$AG,$IAG,S1,$XS,$GO,$SN,INF,IER)
          $ELSE
            CALL UXD$(JASA)HF($N,NA,$AG,$IAG,$XS,$GO,INF)
          $ENDIF
          $IF(MOS4=2)
            CALL UXD$(JASA)HP($N,NA,$AG,$IAG,S1,$GO,$SN,INF,IER)
          $ELSEIF(MOS4=1)
            CALL UXD$(JASA)HR($N,NA,$AG,$IAG,S1,INF,IER)
          $ENDIF
          IDECA=3
          $IF(MOS3=2)
            CALL UXD$(JASA)TF($N,NA,$AG,$IAG,$GS,IER)
            IDECA=4
          $ENDIF
        $ENDIF
        NDECA=NDECA+1
        ENDIF
        CALL UXVCOP(NA,$AF,$AFO)
        $IF(MOS2=1)
          CALL UXECHB(NA,$N,$AG,$AFO,$XS,IER)
          CALL UXVCOP($N,$AFO,$GO)
          CALL UXECRB(IER,NA,$AG,$AFO,-1)
          CALL UXECTB(NA,$N,$AG,$AFO,$GS,IER)
          CALL UXVSBP($N,$IAG,$AFO,$SN)
          CALL UXVCOP($N,$AFO,$SN)
        $ELSE
          CALL UXD$(JASA)HB($N,NA,$AG,$IAG,$AFO,$XS,INF)
          CALL UXVCOP($N,$AFO,$GO)
          CALL UXD$(JASA)UB($N,NA,$AG,$IAG,$AFO,$SN,IER,-1)
          $IF(MOS3=2)
            CALL UXD$(JASA)TB($N,NA,$AG,$IAG,$SN,$GS,IER)
          $ENDIF
          B3=UXVDOT($N,$GN,$GO)
        $ENDIF
      $ELSEIF(DEC='E')
*
*     LU DECOMPOSITION
*
        S1=ETA2
        $IF(LAPACK='YES')
          CALL UXDGLF($N,$AG,$IAG,INF,S1)
        $ELSEIF(MOS2=1)
          CALL UXEGGF($N,$N,$AG,$IAG,INF,S1)
        $ELSE
          CALL UXDGGF($N,$AG,$IAG,INF,S1)
        $ENDIF
        NDECA=NDECA+1
        IDECA=2
        ENDIF
        CALL UXVCOP($N,$AF,$GO)
        $JOB=0
        $IF(LAPACK='YES')
          $IF (JASA='R') $JOB=1
          CALL UXDGLB($N,$AG,$IAG,$GO,$JOB)
        $ELSEIF(MOS2=1)
          $IF (JASA='R') $JOB=1
          CALL UXEGGB($N,$N,$AG,$IAG,$GO,$JOB)
        $ELSE
          $IF (JASA='C') $JOB=1
          CALL UXDGGB($N,$AG,$IAG,$GO,$XO,$JOB)
        $ENDIF
        B3=UXVDOT($N,$GN,$GO)
      $ELSEIF(DEC='Q')
*
*     QR DECOMPOSITION
*
        S1=ETA2
        $IF(MOS3=1)
          CALL UX$(POMD)$(JASA)QF(N,NA,$AG,$H,$XS)
          CALL UX$(POMD)CRC(N,NA,$AG,INF,S1)
        $ELSE
          CALL UXD$(JASA)PF($N,NA,$AG,$H)
          CALL UXDPRC($N,$H,INF,S1)
        $ENDIF
        IF (IPOM1.EQ.1) THEN
        CALL UXVCOP($N,$GN,$GO)
        $IF(MOS3=1)
          CALL UX$(POMD)CRB(N,NA,$AG,$GO,1)
        $ELSE
          CALL UXDPRB($N,$H,$GO,1)
        $ENDIF
        ELSE
        $IF(MOS3=1)
          CALL UXVCOP(NA,$AF,$AFO)
          CALL UX$(POMD)CQB($N,NA,$AG,$AFO,$XS)
          CALL UXVCOP($N,$AFO,$GO)
$REM          CALL UXD$(JASB)MM($POMA,$H,$AFO,$GO)
        $ELSE
          CALL UXD$(JASB)MM($POMA,$H,$AF,$GO)
        $ENDIF
        ENDIF
        NDECA=NDECA+1
        IDECA=1
        ENDIF
        B3=UXVDOT($N,$GO,$GO)
        $IF(MOS3=1)
          CALL UX$(POMD)CRB(N,NA,$AG,$GO,-1)
        $ELSE
          CALL UXDPRB($N,$H,$GO,-1)
        $ENDIF
      $ENDIF
    $ELSEIF(JARA='S')
      $IF(DEC='A')
        $IF(NUMBER=1)
*
*     SPARSE QR DECOMPOSITION
*
          INF=0
          CALL UXVCOP(NA,$AF,$AFO)
          CALL UXSRBF(NA,$N,INF,MMAX,MMAX,MMAX,$IAG,$JAG,$IH&
,$IW1(9*$N+10),$IW1(10*$N+11),$IW2(2*NA+3),$IW2(3*NA+4),$IW2(4*NA+5)&
,$IW2(5*NA+6),$AG,$AFO)
          NDECA=NDECA+1
          IF (INF.GT.0) THEN
          ITERD=-INF
          TDXX='DEC ERR '
          GO TO $30
          ELSE
          IDECA=7
          ENDIF
          ENDIF
          S1=ETA2
          CALL UXSTMB($N,MA,$JAG,$AG,$GO,$AFO,S1)
          CALL UXVSBP($N,$IW1(10*$N+11),$GO,$AFO)
        $ELSE
*
*     SPARSE BUNCH-PARLETT DECOMPOSITION
*
          INF=0
          CALL UXSMIN($N,NA,MA,$AG,$IAG,$JAG,$BG,$IBG)
          CALL UXSIBF(NA+$N,MA+NA+$N,$KBG,$JBG,$BG,MMAX,$IW,MMAX&
,$IW1,$IW2,NAU,NUP,INF)
          NDECA=NDECA+1
          IF (INF.LT.0) THEN
          ITERD=INF
          TDXX='DEC ERR '
          GO TO $30
          ELSE
          IDECA=8
          ENDIF
          ENDIF
          CALL UXVCOP(NA,$AF,$AFO)
          CALL UXVSET($N,ZERO,$AFO(NA+1))
          CALL UXSIBB(NA+$N,$BG,MMAX,$IW,MMAX,$AFD,$AFO,$IW1,NAU,NUP)
          CALL UXVCOP($N,$AFO(NA+1),$GO)
        $ENDIF
      $ELSEIF(DEC='E')
        CALL UXSGMC($N,MA,$AG,$IAG,$JAG,ETA2)
        CALL UXVCOP($N,$AF,$GO)
*
*     SPARSE LU DECOMPOSITION
*
        IF (IDEC.EQ.0) THEN
        IDEC=1
        DO $21 I=1,NA
        DO $11 KA=$IAG(I),$IAG(I+1)-1
        $JBG(KA)=I
$11 CONTINUE
$21 CONTINUE
        CALL UXIINI($JB,INF,1,MMAX+1,1,MMAX+1)
        CALL UXSGDS($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,IB,INF,$CON1&
,$CON2,$CON3,$ICON1,$ICON2,$ICON3,$ICON4,$MOS1,$MOS2)
        ELSE
        CALL UXSGDF($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,IB,INF,$CON2&
,$ICON3)
        ENDIF
        NDECA=NDECA+1
        IDECA=2
        IF (INF.NE.0) THEN
        ITERD=-7
        TDXX='DEC ERR '
        GOTO $30
        ENDIF
        CALL UXSGDB($BG,$IBG,$JB,$N,IB,INF,$GO,$GO,$XO,$CON2,$ICON5&
,0)
      $ENDIF
    $ENDIF
*
*     OPTIMUM DOG-LEG STRATEGY
*
    B3=UXVDOT($N,$GN,$GO)
    D1=B2
    D2=B3
    D3=UXVDOT($N,$GO,$GO)
    G1=B2
    G2=B3
    CALL UNLCS2(B1,B2,B3,D1,D2,D3,G1,G2,S1,S2,XDEL,IER)
    IF (IER.EQ.1) THEN
    CALL UXVSCL($N,S1,$GN,$SN)
    CALL UXVDIR($N,S2,$GO,$SN,$SN)
    SNORM=SQRT(UXVDOT($N,$SN,$SN))
    ITERD=3
    TDXX='DOG MAX3'
    GO TO $20
    ELSE IF (IER.EQ.0) THEN
    CALL UXVNEG($N,$GO,$SN)
    SNORM=SQRT(D3)
    ITERD=1
    TDXX='DOG STEP'
    GO TO $20
    ELSE
    D3=SQRT(D3)
    ENDIF
  $ENDIF
  IF (B1.LE.ZERO.OR.B2*GNORM.GE.B1*XDEL) THEN
*
*     SCALED STEEPEST DESCENT DIRECTION IS ACCEPTED
*
  CALL UXVSCL($N,-XDEL/GNORM,$GN,$SN)
  SNORM=XDEL
  ITERD=3
  TDXX='SD  MAX '
  GO TO $20
  ENDIF
  $IF(MOS<3)
    IF (IDECA.EQ.0) THEN
    $IF(JARA='D')
      $IF(DEC='A')
*
*     HOUSEHOLDER DECOMPOSITION
*
        S1=ETA2
        $IF(MOS2=1)
          S1=SQRT(S1)
          CALL UXECHF(NA,$N,$AG,$IAG,$XS,$GO,$SN,INF)
          CALL UXECHP(NA,$N,$AG,S1,$GO,$SN,INF,IER)
          CALL UXECTF(NA,$N,$AG,$GS,IER)
        $ELSE
          $IF(MOS4=3)
            CALL UXD$(JASA)HC($N,NA,$AG,$IAG,S1,$XS,$GO,$SN,INF,IER)
          $ELSE
            CALL UXD$(JASA)HF($N,NA,$AG,$IAG,$XS,$GO,INF)
          $ENDIF
          $IF(MOS4=2)
            CALL UXD$(JASA)HP($N,NA,$AG,$IAG,S1,$GO,$SN,INF,IER)
          $ELSEIF(MOS4=1)
            CALL UXD$(JASA)HR($N,NA,$AG,$IAG,S1,INF,IER)
          $ENDIF
          IDECA=3
          $IF(MOS3=2)
            CALL UXD$(JASA)TF($N,NA,$AG,$IAG,$GS,IER)
            IDECA=4
          $ENDIF
        $ENDIF
        NDECA=NDECA+1
        ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        CALL UXVCOP(NA,$AF,$AFO)
        $IF(MOS2=1)
          CALL UXECHB(NA,$N,$AG,$AFO,$XS,IER)
          CALL UXECRB(IER,NA,$AG,$AFO,-1)
          CALL UXECTB(NA,$N,$AG,$AFO,$GS,IER)
          CALL UXVSBP($N,$IAG,$AFO,$GO)
          CALL UXVCOP($N,$AFO,$GO)
        $ELSE
          CALL UXD$(JASA)HB($N,NA,$AG,$IAG,$AFO,$XS,INF)
          CALL UXD$(JASA)UB($N,NA,$AG,$IAG,$AFO,$GO,IER,-1)
          $IF(MOS3=2)
            CALL UXD$(JASA)TB($N,NA,$AG,$IAG,$GO,$GS,IER)
          $ENDIF
        $ENDIF
      $ELSEIF(DEC='E')
*
*     LU DECOMPOSITION
*
        S1=ETA2
        $IF(LAPACK='YES')
          CALL UXDGLF($N,$AG,$IAG,INF,S1)
        $ELSEIF(MOS2=1)
          CALL UXEGGF($N,$N,$AG,$IAG,INF,S1)
        $ELSE
          CALL UXDGGF($N,$AG,$IAG,INF,S1)
        $ENDIF
        NDECA=NDECA+1
        IDECA=2
        ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        CALL UXVCOP($N,$AF,$GO)
        $JOB=0
        $IF(LAPACK='YES')
          $IF (JASA='R') $JOB=1
          CALL UXDGLB($N,$AG,$IAG,$GO,$JOB)
        $ELSEIF(MOS2=1)
          $IF (JASA='R') $JOB=1
          CALL UXEGGB($N,$N,$AG,$IAG,$GO,$JOB)
        $ELSE
          $IF (JASA='C') $JOB=1
          CALL UXDGGB($N,$AG,$IAG,$GO,$XO,$JOB)
        $ENDIF
      $ELSEIF(DEC='Q')
*
*     QR DECOMPOSITION
*
        S1=ETA2
        $IF(MOS3=1)
          CALL UX$(POMD)$(JASA)QF(N,NA,$AG,$H,$XS)
          CALL UX$(POMD)CRC(N,NA,$AG,INF,S1)
        $ELSE
          CALL UXD$(JASA)PF($N,NA,$AG,$H)
          CALL UXDPRC($N,$H,INF,S1)
        $ENDIF
        IF (IPOM1.EQ.1) THEN
        CALL UXVCOP($N,$GN,$GO)
        $IF(MOS3=1)
          CALL UX$(POMD)CRB(N,NA,$AG,$GO,1)
        $ELSE
          CALL UXDPRB($N,$H,$GO,1)
        $ENDIF
        ELSE
        $IF(MOS3=1)
          CALL UXVCOP(NA,$AF,$AFO)
          CALL UX$(POMD)CQB(N,NA,$AG,$AFO,$XS)
          CALL UXVCOP($N,$AFO,$GO)
$REM          CALL UXD$(JASB)MM($POMA,$H,$AFO,$GO)
        $ELSE
          CALL UXD$(JASB)MM($POMA,$AG,$AF,$GO)
        $ENDIF
        ENDIF
        NDECA=NDECA+1
        IDECA=1
        ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        $IF(MOS3=1)
          CALL UX$(POMD)CRB(N,NA,$AG,$GO,-1)
        $ELSE
          CALL UXDPRB($N,$H,$GO,-1)
        $ENDIF
      $ENDIF
    $ELSEIF(JARA='S')
      $IF(DEC='A')
        $IF(NUMBER=1)
*
*     SPARSE QR DECOMPOSITION
*
          INF=0
          CALL UXVCOP(NA,$AF,$AFO)
          CALL UXSRBF(NA,$N,INF,MMAX,MMAX,MMAX,$IAG,$JAG,$IH&
,$IW1(9*$N+10),$IW1(10*$N+11),$IW2(2*NA+3),$IW2(3*NA+4),$IW2(4*NA+5)&
,$IW2(5*NA+6),$AG,$AFO)
          NDECA=NDECA+1
          IF (INF.GT.0) THEN
          ITERD=-INF
          TDXX='DEC ERR '
          GO TO $30
          ELSE
          IDECA=7
          ENDIF
          ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
          S1=ETA2
          CALL UXSTMB($N,MA,$JAG,$AG,$GO,$AFO,S1)
          CALL UXVSBP($N,$IW1(10*$N+11),$GO,$AFO)
        $ELSE
*
*     SPARSE BUNCH-PARLETT DECOMPOSITION
*
          INF=0
          CALL UXSMIN($N,NA,MA,$AG,$IAG,$JAG,$BG,$IBG)
          CALL UXSIBF(NA+$N,MA+NA+$N,$KBG,$JBG,$BG,MMAX,$IW,MMAX&
,$IW1,$IW2,NAU,NUP,INF)
          NDECA=NDECA+1
          IF (INF.LT.0) THEN
          ITERD=INF
          TDXX='DEC ERR '
          GO TO $30
          ELSE
          IDECA=8
          ENDIF
          ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
          CALL UXVCOP(NA,$AF,$AFO)
          CALL UXVSET($N,ZERO,$AFO(NA+1))
          CALL UXSIBB(NA+$N,$BG,MMAX,$IW,MMAX,$AFD,$AFO,$IW1,NAU,NUP)
          CALL UXVCOP($N,$AFO(NA+1),$GO)
        $ENDIF
      $ELSEIF(DEC='E')
        CALL UXSGMC($N,MA,$AG,$IAG,$JAG,ETA2)
        CALL UXVCOP($N,$AF,$GO)
*
*     SPARSE LU DECOMPOSITION
*
        IF (IDEC.EQ.0) THEN
        IDEC=1
        DO $22 I=1,NA
        DO $12 KA=$IAG(I),$IAG(I+1)-1
        $JBG(KA)=I
$12 CONTINUE
$22 CONTINUE
        CALL UXIINI($JB,INF,1,MMAX+1,1,MMAX+1)
        CALL UXSGDS($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,$IB,INF,$CON1&
,$CON2,$CON3,$ICON1,$ICON2,$ICON3,$ICON4,$MOS1,$MOS2)
        ELSE
        CALL UXSGDF($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,$IB,INF,$CON2&
,$ICON3)
        ENDIF
        NDECA=NDECA+1
        IDECA=2
        IF (INF.NE.0) THEN
        ITERD=-7
        TDXX='DEC ERR '
        GOTO $30
        ENDIF
        ENDIF
*
*     COMPUTATION OF THE NEWTON DIRECTION
*
        CALL UXSGDB($BG,$IBG,$JB,$N,IB,INF,$GO,$GO,$XO,$CON2,$ICON5&
,0)
      $ENDIF
    $ENDIF
  $ENDIF
  D3=SQRT(UXVDOT($N,$GO,$GO))
*
*     COMPUTATION OF THE STEEPEST DESCENT DIRECTION
*
  B2=B2/B1
  SNORM=B2*GNORM
  CALL UXVSCL($N,-B2,$GN,$SN)
  CALL UXVNEG($N,$GO,$GO)
  CALL UXVDIF($N,$GO,$SN,$XO)
  B1=UXVDOT($N,$SN,$XO)
  B2=UXVDOT($N,$XO,$XO)
  IF (B2.LE.$CON0*XDEL*XDEL) THEN
*
*     NEWTON AND THE STEEPEST DESCENT DIRECTION ARE
*     APPROXIMATELY EQUAL
*
  CALL UXVCOP($N,$GO,$SN)
  SNORM=D3
  ITERD=1
  TDXX='DOG STEP'
  ELSE IF (B1.LE.ZERO) THEN
*
*     BOUNDARY STEP WITH NEGATIVE INCREMENT
*
  CALL UNSTEP(XDEL,SNORM,-B1,B2,B3)
  CALL UXVDIR($N,-B3,$XO,$SN,$SN)
  SNORM=XDEL
  ITERD=3
  TDXX='DOG NEG '
  ELSE IF (D3.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UXVCOP($N,$GO,$SN)
  SNORM=D3
  ITERD=1
  TDXX='DOG STEP'
  ELSE
  $IF(MOS=1)
*
*     SINGLE DOGLEG STRATEGY
*
    CALL UNSTEP(XDEL,SNORM,B1,B2,B3)
    CALL UXVDIR($N,B3,$XO,$SN,$SN)
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX1'
  $ELSE
*
*     DOUBLE DOGLEG STRATEGY
*
    D3=XDEL/D3
    B3=UXVDOT($N,$SN,$GO)
    D3=MAX(D3,SNORM*SNORM/B3)
    CALL UXVDIR($N,-D3,$GO,$SN,$XO)
    B1=SNORM*SNORM-D3*B3
    B2=UXVDOT($N,$XO,$XO)
    CALL UNSTEP(XDEL,SNORM,-B1,B2,B3)
    CALL UXVDIR($N,-B3,$XO,$SN,$SN)
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX2'
  $ENDIF
  ENDIF
$20 CONTINUE
  $IF(JARA='D')
    IF (IDECA.EQ.0) THEN
    $IF(DEC='A')
      CALL UXD$(JASA)MM($POMA,$AG,$SN,$AFO)
        PP=UXVDOT(NA,$AFO,$AFO)*HALF
      ELSE
      $IF(MOS2=1)
        CALL UXVCOP($N,$SN,$GO)
        CALL UXVSFP($N,$IAG,$GO,$XO)
        CALL UXECTM(NA,$N,$AG,$GO,$GS,IER)
        CALL UXECRM(IER,NA,$AG,$GO,1)
        PP=UXVDOT($N,$GO,$GO)*HALF
      $ELSE
        CALL UXVCOP($N,$SN,$GO)
        $IF(MOS3=2)
          CALL UXD$(JASA)TM($N,NA,$AG,$IAG,$GO,$GS,IER)
        $ENDIF
        CALL UXD$(JASA)UM($N,NA,$AG,$IAG,$GO,$AFO,IER,0)
        PP=UXVDOT(NA,$AFO,$AFO)*HALF
      $ENDIF
      ENDIF
    $ELSEIF(DEC='E')
      CALL UXD$(JASA)MM($POMA,$AG,$SN,$GO)
      ELSE
      CALL UXVCOP($N,$SN,$GO)
      $JOB=0
      $IF(LAPACK='YES')
        $IF (JASA='R') $JOB=1
        CALL UXDGLM($N,$AG,$IAG,$GO,$JOB)
      $ELSEIF(MOS2=1)
        $IF (JASA='R') $JOB=1
        CALL UXEGGM($N,$N,$AG,$IAG,$GO,$JOB)
      $ELSE
        $IF (JASA='C') $JOB=1
        CALL UXDGGM($N,$AG,$IAG,$GO,$XO,$JOB)
      $ENDIF
      ENDIF
      PP=UXVDOT($N,$GO,$GO)*HALF
    $ELSEIF(DEC='Q')
      CALL UXD$(JASA)MM($POMA,$AG,$SN,$AFO)
      PP=UXVDOT(NA,$AFO,$AFO)*HALF
      ELSE
      CALL UXVCOP($N,$SN,$GO)
      $IF(MOS3=1)
        CALL UX$(POMD)CRM(N,NA,$AG,$GO,1)
      $ELSE
        CALL UXDPRM($N,$H,$GO,1)
      $ENDIF
      PP=UXVDOT($N,$GO,$GO)*HALF
      ENDIF
    $ENDIF
  $ELSEIF(JARA='S')
    $IF(DEC='A')
      CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$SN,$AFO)
      PP=UXVDOT(NA,$AFO,$AFO)*HALF
    $ELSEIF(DEC='E')
      CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$SN,$AFO)
      PP=UXVDOT(NA,$AFO,$AFO)*HALF
    $ENDIF
  $ENDIF
$30 CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(JARA)G$(DEC)1'
  $ENDADD
  $EXIT
