$INTERFACE ULQDB1                                             97/12/01
    $DEFAULT='1.0$P-10'
    $IF(MODEL='FL') $DEFAULT='1.0$P-5'
    $HELP
      TOLERANCE FOR POSITIVE DEFINITENESS
    $CHECK(ETA2,DEFAULT,REAL,4)
    $HELP
      PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING
      SUBROUTINE
    $CHECK(EPS7,'1.0$P-15',REAL,4)
    $HELP
      TOLERANCE FOR ACTIVE CONSTRAINTS
    $CHECK(EPS9,'1.0$P-8',REAL,4)
    CALL ULQDB1(NF,N,MCL,$X,$IX,$IXA,$XN,$XL,$XU,$CF,$CFD,$IC,$ICA,$CL&
,$CU,$CG,$CR,$CZ,$G,$GO,$H,$S,ETA2,$ETA9,EPS7,EPS9,XDEL,UMAX,GMAX&
,MFP,$JOB)
    $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)\$CF($MCL)\$CFD($MCL)&
    \$CL($MCL)\$CU($MCL)\$CG($NF*$MCL)\$CR($NF*($NF+1)/2)\$CZ($NF)&
    \$G($NF)\$GO($NF)\$H($NF*($NF+1)/2)\$S($NF)')
$REM    $ADD(REAL,'\XDEL\UMAX\GMAX\ETA2\EPS7\EPS9')
$REM    $ADD(INTEGER,'\NF\N\NC\MFP')
    $ADD(INTEGER,'\$IX($NX)\$IXA($NX)\$IC($MCL)\$ICA($NF)')
    $ADD(INIT)
    NQPX='ULQDB1'
    $ENDADD
    $EXIT
