$INTERFACE ULQDF1                                             06/12/01
    $HELP
      TYPE OF EXTREMUM:
         0 - CHEBYSHEV APPROXIMATION
        -1 - MINIMAX
         1 - MAXIMIN
    $CHECK(IEXT,0,'-1\0\1',1)
    $HELP
      TOLERANCE FOR POSITIVE DEFINITENESS
    $CHECK(ETA2,ETA0,REAL,4)
    $HELP
      PRECISION FOR EITHER LINEAR OR QUADRATIC PROGRAMMING
      SUBROUTINE
    $CHECK(EPS7,'1.0$P-10',REAL,4)
    $HELP
      TOLERANCE FOR ACTIVE CONSTRAINTS
    $CHECK(EPS9,'1.0$P-8',REAL,4)
    $IF($DEF(DECOMP))
      $IF(DECOMP=10)
        $ADD(REAL,'\$H($NF)')
        IDECF=10
      $ELSE
        $ADD(REAL,'\$H($NF*($NF+1)/2)')
      $ENDIF
    $ELSE
      $ADD(REAL,'\$H($NF*($NF+1)/2)')
    $ENDIF
    CALL ULQDF1(NF,N,MAL,MCL,$X,$IX,$IXA,$XN,$XL,$XU,$AF,$AFD,$IA,$IAA&
,$AG,$AR,$AZ,$CF,$IC,$CL,$CU,$CG,$G,$H,$S,$ETA0,ETA2,$ETA9,EPS7,EPS9&
,XDEL,XNORM,UMAX,GMAX,MFP,$JOB)
    $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)\$AF($MAL)\$AFD($MAL)&
    \$AG($NF*($MAL))\$AR(($NF+1)*($NF+2)/2)\$AZ($NF+1)\$CF($MCL)&
    \$CL($MCL)\$CU($MCL)\$CG($NF*$MCL)\$G($NF+1)\$S($NF+1)')
$REM    $ADD(REAL,'\XDEL\XNORM\UMAX\GMAX\ETA2\EPS7\EPS9')
$REM    $ADD(INTEGER,'\NF\N\MAL\MCL\MFP')
    $ADD(INTEGER,'\$IX($NX)\$IXA($NX)\$IAA($NF+1)\$IC($MCL)')
    $IF(IEXT=0)
      $ADD(INTEGER,'\$IA(2*($MAL))')
    $ELSE
$REM      $ADD(INTEGER,'\$IA($MAL)')
      $ADD(INTEGER,'\$IA(2*($MAL))')
    $ENDIF
    $ADD(INIT)
      NQPX='ULQDF1'
    $ENDADD
    $EXIT
