$INTERFACE UULSP1                                             02/12/01
  $GR='GR'
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - VARIATIONALLY DERIVED PRECONVEX UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6',3)
  $HELP
    SELECTION OF SELF SCALING:
      ABS(MET1)=1 - SELF SCALING SUPPRESSED
      ABS(MET1)=2 - INITIAL SELF SCALING
      ABS(MET1)=3 - CONTROLLED SELF SCALING
      ABS(MET1)=4 - SIMPLIFIED CONTROLLED SELF SCALING
      ABS(MET1)=5 - SELF SCALING IN EACH ITERATION
           MET1>0 - BASIC INITIAL SELF SCALING
           MET1<0 - MODIFIED INITIAL SELF SCALING
  $CHECK(MET1,1,'-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $IF(NET1=-3) $NET1=3
  $IF(NET1=-4) $NET1=4
  $IF(NET1=-5) $NET1=5
  $IF($DEF(MET3DEF))
  $ELSE
    $MET3DEF='MET3'
    $HELP
      COMPUTATION OF THE WEIGHTING PARAMETER:
        0 - PREVIOUS CHOICE
        1 - SIMPLE CHOICE WITH A CONSTANT RELATIVE PARAMETER
        2 - USING QUADRATIC EQUATION
        3 - HEURISTIC CHOICE WITH A RELATIVE PARAMETER LESS
            THEN HALF
        4 - HEURISTIC CHOICE WITH THE OPTIMUM CONDITION NUMBER
            IN THE FIRST ITERATION (FIRST FORMULA)
        5 - HEURISTIC CHOICE WITH THE OPTIMUM CONDITION NUMBER
            IN THE FIRST ITERATION (SECOND FORMULA)
        6 - HEURISTIC CHOICE DERIVED FROM THE LOWEST EIGENVALUE
    $CHECK(MET3,4,'0\1\2\3\4\5\6',4)
  $ENDIF
  $ADD(REAL,'\$XM($NF*$MF)\$GR($MF)\$XO($NF)\$GO($NF)')
$REM  $ADD(INTEGER,'\NF\MF\INF')
  CALL UULSP1(NF,NN,MF,$XM,$GR,$XO,$GO,R,F,FO,P,PO,PAR&
,PAR1,PAR2,$CON1,MET,MET1,1,$MET3DEF,1)
  $ADD(INIT)
    NUXX='UULSP1'
  $ENDADD
  $EXIT
