$INTERFACE UYFUT1                                             98/12/01
  $IF ($DEF(LOCALSTOP))
    $LOCALSTOP
  $ENDIF
  $IF(CLASS<>'CD')
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES1,999,INT,4)
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES2,0,INT,4)
  $ENDIF
  $HELP
    MAXIMUM NUMBER OF TESTS ON STEPLENGTH
  $CHECK(MTESX,2,INT,4)
  $HELP
    MAXIMUM NUMBER OF TESTS ON FUNCTION DECREASE
  $CHECK(MTESF,2,INT,4)
  $HELP
    MAXIMUM NUMBER OF ITERATIONS
  $CHECK(MIT,1000,INT,3)
  $HELP
    MAXIMUM NUMBER OF COMPUTED FUNCTION VALUES
  $CHECK(MFV,1000,INT,3)
  $HELP
    MAXIMUM NUMBER OF COMPUTED GRADIENT VALUES
  $CHECK(MFG,10000,INT,3)
  $HELP
    LOWER BOUND FOR STEPLENGTH
  $CHECK(TOLX,'1.0$P-16',REAL,3)
  $HELP
    LOWER BOUND FOR FUNCTION DECREASE
  $CHECK(TOLF,'1.0$P-14',REAL,3)
  $DEFAULT='-$ETA9'
  $IF($DEF(FMIN))
    $IF(FMIN='0.0$P 0') $DEFAULT='1.0$P-16'
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(TOLB,DEFAULT,REAL,3)
  $IF(KD<>0)
    $DEFAULT='1.0$P-6'
    $IF(KDF=0) $DEFAULT='1.0$P-5'
    $HELP
      LOWER BOUND FOR GRADIENT
    $CHECK(TOLG,DEFAULT,REAL,3)
  $ENDIF
  CALL UYFUT1($N,$F,$FO,UMAX,GMAX,DMAX,ITES,IRES1,IRES2,INEW)
$REM  $ADD(INTEGER,'\$N\ITES\INEW')
$REM  $ADD(REAL,'\F\FO\UMAX\GMAX\DMAX')
  $ADD(INIT)
    ITES=1
  $ENDADD
  $EXIT
