$INTERFACE UDDXQ1                                             97/12/01
$REM LU
  $HELP
    TYPE OF QP SUBPROBLEM
      1 - COMPLETE QP SUBPROBLEM
      2 - PARTIAL QP SUBPROBLEM WITH CHECK OF ACTIVITY
      3 - PARTIAL QP SUBPROBLEM
  $CHECK(MOS,1,'1\2\3',3)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    INITIAL TRUST REGION BOUND
  $CHECK(XDEL,XMAX,REAL,3)
  $HELP
    TOLERANCE FOR NEAR ACTIVITY
  $CHECK(ETA4,'1.0$P 0',REAL,4)
  $ADD(REAL,'\$AF($MAL)\$AG($NF*($MAL))\$H($M)\$S($NF)\$G($NF)')
  $ADD(INTEGER,'\$IXA($NF)\$IA($MAL)')
  $IF(MOS>1)
    $ADD(REAL,'\POM')
    $ADD(INTEGER,'\$IAS($MAL)')
    $IF(MOS=2) $ADD(INTEGER,'\JAG')
  $ENDIF
  $ADD(REAL,'\UXVDOT\UXVMAX')
  $ADD(INTEGER,'\IPOM\I')
  CALL UOD1D1
  IF (IDECF.LT.0) IDECF=1
  IF (IDECF.EQ.0) THEN
  ELSE IF (IDECF.EQ.1) THEN
  ELSE IF (IDECF.EQ.2) THEN
  CALL UXDPRT(N,$H)
  IDECF=1
  ELSE IF (IDECF.EQ.9) THEN
  ELSE
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UDDXQ1',1)
  GO TO $70
  ENDIF
  MFP=2
  $IF(MOS>1)
    XNORM=F
    DO $20 KA=1,MAL
    IF ($IA(KA).GT.0) THEN
    POM=$AF(KA)
    IF ($IA(KA).EQ.1.OR.$IA(KA).GE.3.AND.POM.LT.ZERO) POM=-POM
    IF (POM.GE.XNORM-ETA4*MAX(ABS(XNORM),ONE)) THEN
    $IAS(KA)=0
    ELSE
    $IAS(KA)=$IA(KA)
    $IA(KA)=0
    ENDIF
    ENDIF
$20 CONTINUE
  $ENDIF
  MODE=1
$30 CONTINUE
  $JOB=1
  $QPCON='F'
  $IF(MCL=0) $QPCON='A'
  $IF(NUMBER=1)
    $SUBST('ULQD$(QPCON)1')
  $ELSE
    $SUBST('ULQP$(QPCON)2')
  $ENDIF
  IF (ITERQ.LT. 0) THEN
  IF (ITERQ.EQ.-1) THEN
  TDXX='NON FEAS'
  ELSE
  TDXX='INVALID '
  ENDIF
  ITERD=ITERQ-10
  GO TO $70
  ENDIF
  IPOM=0
  $IF(MOS>1)
    IPOM=1
    $IF(MOS=2)
      JAG=0
      DO $50 KA=1,MAL
      IF ($IAS(KA).NE.0) THEN
      POM=$AF(KA)+UXVDOT(NF,$AG(JAG+1),$S)
      IF ($IA(KA).EQ.1.OR.$IA(KA).GE.3.AND.POM.LT.ZERO) POM=-POM
      IF (POM.GT.XNORM) THEN
      IPOM=2
      $IA(KA)=$IAS(KA)
      $IAS(KA)=0
      ENDIF
      ENDIF
      JAG=JAG+NF
$50   CONTINUE
    $ENDIF
    IF (IPOM.EQ.2) THEN
    MFP=3
    MODE=2
    GO TO $30
    ELSE IF (IPOM.EQ.1) THEN
    DO $60 KA=1,MAL
    IF ($IAS(KA).NE.0) THEN
    $IA(KA)=$IAS(KA)
    $IAS(KA)=0
    ENDIF
$60 CONTINUE
    ENDIF
  $ENDIF
  ITERD=1
  TDXX='QD STEP '
  GMAX=UXVMAX(NF,$G)
  IF (LCS.GT.0) THEN
  GNORM=GMAX
  SNORM=UXVMAX(NF,$S)
  ELSE
  GNORM=SQRT(UXVDOT(NF,$G,$G))
  SNORM=SQRT(UXVDOT(NF,$S,$S))
  ENDIF
  IF (GMAX.LE.TOLG*(MIN(ONE,ABS(F)))) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
$70 IF (LCS.GT.0) THEN
  DO $80 I=1,NF
  IF ($IXA(I).GE.0) ITERD=3
$80 CONTINUE
  ENDIF
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDDXQ1'
  $ENDADD
  $EXIT
