$INTERFACE UP2LQ5                                             99/12/01
  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    INITIAL VALUE OF SLACK VARIABLES
  $CHECK(EPS7,'1.0$P-1',REAL,4)
  $HELP
    INITIAL VALUE OF LAGRANGE MULTIPLIERS
  $CHECK(EPS8,'1.0$P-1',REAL,4)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$GF($NF)\$HF($M)\$CF($NC+1),$CL($NC)\$CU($NC)\$CSL($NC)&
  \$CSU($NC)\$CZL($NC)\$CZU($NC)\$CG($MC)\$GC($NF)\$G($NF)\$H($M)')
$REM  $ADD(REAL,'\EPS7\EPS8\FF\FC\F\CMAX')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICG($NC+1)\$JCG($MC)\$IH($NF+1)&
  \$JH($M)')
$REM  $ADD(INTEGER,'\NF\NX\NC\MC\KC')
  CALL UP2LQ5(NF,NX,NC,MC,KC,$IH(NF+1)-1,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL&
,$XZU,$GF,$HF,$CF,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$CG,$GC,$ICG&
,$JCG,$G,$H,$IH,$JH,EPS7,EPS8,FF,FC,F,CMAX)
  $ADD(INIT)
    NPXX='UP2LQ5'
  $ENDADD
  $EXIT
