$INTERFACE UUBSD2                                             97/12/01
  $HELP
    MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
  $CHECK(MAH,'25*$NA',INT,1)
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'1\2',4)
  $DEFAULT='5.0D-4'
  $IF(TYPE='L') $DEFAULT='2.0D-2'
  $HELP
    TOLERANCE FOR APPLICATION OF THE BFGS METHOD
  $CHECK(ETA5,DEFAULT,REAL,4)
  $ADD(REAL,'\$AH($MAH)\$AB($MAH)')
$REM  $ADD(REAL,'\F\FO\ETA5')
  $ADD(INTEGER,'\$IA($NA)\$IAG($NA+1)')
$REM  $ADD(INTEGER,'\$N\NA\NAL\MAH')
  $N='NF'
  CALL UUBSD2($N,NA,NAL,MAH,$IA,$AH,$AB,$IAG,F,FO,ETA5,$INITH)
  $ADD(SINIT)
    CALL UXVINS(NA,3,$IA)
  $ENDADD
  $EXIT
