$INTERFACE UUDGA2                                             17/12/01
$REM LU
  $POMD='D'
  $POMH=H
  $POMN='N'
  $ADD(REAL,'\$AG($NF*$NA)\$AGO($NF*$NA)\$AF($NA)\$G($NF)\$S($NF)&
  \$XO($NF)\$GO($NF)\$AFO($NA)')
  $POM1='$N,NA'
  $POM2='N,NA'
  $ADD(POM1,',$AG,$AGO,$AF,$G,$S,$XO,$GO,$AFO')
  $ADD(POM2,',AG,AGO,AF,G,S,XO,GO,AFO')
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDG$(DEC)2$(NUMSUB)($POM1)
  $ADD(SUBROUTINES)
*     ----------------------------------
*     FACTORIZED VARIABLE METRIC UPDATES
*     TEMPLATE : UUDGA2
*     ----------------------------------
  SUBROUTINE UUDG$(DEC)2$(NUMSUB)($POM2)
  $$INCLUDE('UMCOMM')
  INTEGER N,NA,MET
  $$FLOAT AG(N*NA),AF(NA),G(N),S(N),XO(N),GO(N),AFO(NA)
  $$FLOAT UXVDOT
  $$FLOAT A,B,C,DEN
*  CALL UOU1D1(N,XO,GO)
  $$I=0
  IF (IDECA.NE.0) THEN
  ITERH=-1
  TUXX='BAD DEC$$I'
  CALL UOERR1('UUDG$(DEC)1',1)
  GO TO 22
  ENDIF
*
*     THE SHENG AND ZHOU UPDATE
*
  CALL UXD$(JASA)MM($POMA,AGO,XO,AFO)
  CALL UXD$(JASA)MD($POMA,AG,XO,ONE,AFO,AFO)
  DEN=UXVDOT(NA,AF,AF)
  CALL UXVDIR(NA,-UXVDOT(NA,AF,AFO)/DEN,AF,AFO,AFO)
  CALL UXVDIR(N,-UXVDOT(N,G,XO)/DEN,G,GO,GO)
  CALL UXD$(JASB)MM($POMA,AGO,AFO,S)
  CALL UXD$(JASB)MD($POMA,AG,AFO,ONE,S,S)
  A=ZERO
  B=UXVDOT(N,XO,GO)
  IF (B.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG'
  GO TO 22
  ENDIF
  C=UXVDOT(NA,AFO,AFO)
  IF (C.LE.ZERO) THEN
  ITERH=2
  TUXX='C - NEG'
  GO TO 22
  ENDIF
  CALL UXVDIR(N,-SQRT(C/B),GO,S,S)
  CALL UXD$(JASB)MM($POMA,AGO,AF,XO)
  CALL UXD$(JASA)MU($POMA,AGO,-ONE/DEN,AF,XO)
  CALL UXD$(JASA)MU($POMA,AGO,-ONE/C,AFO,S)
  NUPD=NUPD+1
  ITERH=0
22 CONTINUE
*  CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDG$(DEC)2'
  $ENDADD
  $EXIT
