$INTERFACE UYFUT2                                             98/12/01
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,100,INT,4)
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES2,0,INT,4)
  $HELP
    MAXIMUM NUMBER OF TESTS ON STEPLENGTH
  $CHECK(MTESX,2,INT,4)
  $HELP
    MAXIMUM NUMBER OF CYCLES
  $CHECK(MIC,5,INT,3)
  $HELP
    MAXIMUM NUMBER OF ITERATIONS
  $CHECK(MIT,1000,INT,3)
  $HELP
    MAXIMUM NUMBER OF COMPUTED FUNCTION VALUES
  $CHECK(MFV,1000,INT,3)
  $HELP
    MAXIMUM NUMBER OF COMPUTED GRADIENT VALUES
  $CHECK(MFG,10000,INT,3)
  $HELP
    LOWER BOUND FOR STEPLENGTH
  $CHECK(TOLX,'1.0$P-16',REAL,3)
  $HELP
    LOWER BOUND FOR CONSTRAINT VIOLATION
  $CHECK(TOLC,'1.0$P-6',REAL,3)
  $IF(KD<>0)
    $HELP
      LOWER BOUND FOR GRADIENT OF THE
      LAGRANGIAN FUNCTION
    $CHECK(TOLG,'1.0$P-6',REAL,3)
  $ENDIF
  $DEFAULT='-$ETA9'
  $IF($DEF(FMIN))
    $IF(FMIN='0.0$P 0') $DEFAULT='1.0$P-16'
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(TOLB,DEFAULT,REAL,3)
  CALL UYFUT2(NF,DMAX,ITES,IRES1,IRES2)
$REM  $ADD(INTEGER,'\NF\ITES')
$REM  $ADD(REAL,'\DMAX')
  $ADD(INIT)
    ITES=1
  $ENDADD
  $EXIT
