$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZMODY                                    01/12/97  +
$REM + SI                                                            +
$REM + PURPOSE:  SPECIFICATION OF MODEL OF APPROXIMATED FUNCTIONS    +
$REM +---------------------------------------------------------------+

$LDY=-1
$GMODY='X'
$IF($DEF(FMODELYS))
  $FMODELY=FMODELYS
  $ERASE(FMODELYS)
  $LDY=0
$ENDIF
$IF($DEF(FMODELY))
  $FMODY='F'
  $KDY=0
  $IF($DEF(GMODELYS))
    $IF(LDY<0)
      $ERROR SIMULTANEOUS COMPUTATION IS NOT ALLOWED : LDY < 0
      $STOP
    $ENDIF
    $GMODELY=GMODELYS
    $ERASE(GMODELYS)
    $LDY=1
  $ENDIF
  $IF($DEF(GMODELY))
    $GMODY='G'
    $KDY=1
  $ENDIF
  $MODELY='YES'
  $EXIT
$ENDIF
$IF($DEF(FGMODELYS))
  $FGMODELY=FGMODELYS
  $ERASE(FGMODELYS)
  $LDY=1
$ENDIF
$IF($DEF(FGMODELY))
  $FMODY='FG'
  $KDY=1
  $MODELY='YES'
  $EXIT
$ENDIF
$HELP
  MODEL OF THE APPROXIMATED FUNCTION

  FE = <FORTRAN_EXPRESSION>
$CHECK(FMODELY,'*',STR,1,NO)
$IF(FMODELY='*')
$ELSE
  $FMODY='F'
  $KDY=0
  $MODELY='YES'
  $HELP
    MODEL OF GRADIENT OF THE APPROXIMATED FUNCTION

      GE(1)  = <FORTRAN_EXPRESSION>
      GE(2)  = <FORTRAN_EXPRESSION>
        .
        .
      GE(NF) = <FORTRAN_EXPRESSION>
  $CHECK(GMODELY,'*',STR,1,NO)
  $IF(GMODELY='*')
    $ERASE(GMODELY)
  $ELSE
    $GMODY='G'
    $KDY=1
  $ENDIF
$ENDIF

